diff -ruN postfixadmin.orig/lib/smarty/libs/plugins/function.html_options.php postfixadmin/lib/smarty/libs/plugins/function.html_options.php
--- postfixadmin.orig/lib/smarty/libs/plugins/function.html_options.php	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/lib/smarty/libs/plugins/function.html_options.php	2022-06-07 12:49:08.036597000 +0300
@@ -191,7 +191,7 @@
         } else {
             $value = smarty_function_escape_special_chars((string)$value);
         }
-        $_html_result .= $_html_class . $_html_id . '>' . $value . '</option>' . "\n";
+        $_html_result .= $_html_class . $_html_id . '>' . idn_to_utf8($value) . '</option>' . "\n";
         $idx++;
     } else {
         $_idx = 0;
diff -ruN postfixadmin.orig/lib/smarty/libs/plugins/function.html_select_date.php postfixadmin/lib/smarty/libs/plugins/function.html_select_date.php
--- postfixadmin.orig/lib/smarty/libs/plugins/function.html_select_date.php	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/lib/smarty/libs/plugins/function.html_select_date.php	2022-06-07 10:51:20.904032000 +0300
@@ -309,8 +309,8 @@
         for ($i = 1; $i <= 12; $i++) {
             $_val = sprintf('%02d', $i);
             $_text = isset($month_names) ? smarty_function_escape_special_chars($month_names[ $i ]) :
-                ($month_format === '%m' ? $_val : strftime($month_format, $_month_timestamps[ $i ]));
-            $_value = $month_value_format === '%m' ? $_val : strftime($month_value_format, $_month_timestamps[ $i ]);
+                ($month_format === '%m' ? $_val : @strftime($month_format, $_month_timestamps[ $i ]));
+            $_value = $month_value_format === '%m' ? $_val : @strftime($month_value_format, $_month_timestamps[ $i ]);
             $_html_months .= '<option value="' . $_value . '"' . ($_val == $_month ? ' selected="selected"' : '') .
                              '>' . $_text . '</option>' . $option_separator;
         }
diff -ruN postfixadmin.orig/lib/smarty/libs/plugins/modifier.date_format.php postfixadmin/lib/smarty/libs/plugins/modifier.date_format.php
--- postfixadmin.orig/lib/smarty/libs/plugins/modifier.date_format.php	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/lib/smarty/libs/plugins/modifier.date_format.php	2022-06-07 10:52:22.022221000 +0300
@@ -78,7 +78,7 @@
             }
             $format = str_replace($_win_from, $_win_to, $format);
         }
-        return strftime($format, $timestamp);
+        return @strftime($format, $timestamp);
     } else {
         return date($format, $timestamp);
     }
diff -ruN postfixadmin.orig/model/AliasHandler.php postfixadmin/model/AliasHandler.php
--- postfixadmin.orig/model/AliasHandler.php	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/model/AliasHandler.php	2022-06-07 09:45:58.424029000 +0300
@@ -469,7 +469,7 @@
     */
     protected function getVacationAlias()
     {
-        $vacation_goto = str_replace('@', '#', $this->id);
+        $vacation_goto = str_replace('@', '#', $this->id||'');
         return $vacation_goto . '@' . Config::read_string('vacation_domain');
     }
  
diff -ruN postfixadmin.orig/model/PFASmarty.php postfixadmin/model/PFASmarty.php
--- postfixadmin.orig/model/PFASmarty.php	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/model/PFASmarty.php	2022-06-03 09:21:13.229435000 +0300
@@ -140,14 +140,16 @@
             return $data; // can't handle
         }
 
-        if (!is_array($data)) {
+        if (isset($data) && !is_array($data)) {
             return htmlentities($data, ENT_QUOTES, 'UTF-8', false);
         }
         $clean = array();
-        foreach ($data as $key => $value) {
-            /* as this is a nested data structure it's more likely we'll output the key too (at least in my opinion, so we'll sanitise it too */
-            $clean[$this->sanitise($key)] = $this->sanitise($value);
-        }
+        if ( isset($data) && is_array($data) ) {
+    	    foreach ($data as $key => $value) {
+        	/* as this is a nested data structure it's more likely we'll output the key too (at least in my opinion, so we'll sanitise it too */
+        	$clean[$this->sanitise($key)] = $this->sanitise($value);
+    	    }
+    	}
         return $clean;
     }
 }
diff -ruN postfixadmin.orig/public/list.php postfixadmin/public/list.php
--- postfixadmin.orig/public/list.php	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/public/list.php	2022-06-07 14:51:04.211202000 +0300
@@ -139,7 +139,9 @@
             $values = $item[$column];
             if (is_array($values)) {
                 $values = implode(',', $values);
-            }
+            } else {
+        	$values = idn_to_utf8($values);
+    	    }
             $fields[] = $values;
         }
         fputcsv($out, $fields);
diff -ruN postfixadmin.orig/templates/editform.tpl postfixadmin/templates/editform.tpl
--- postfixadmin.orig/templates/editform.tpl	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/templates/editform.tpl	2022-06-07 13:00:10.621216000 +0300
@@ -18,7 +18,7 @@
                                     {if $field.type == 'enma'}
                                         {$struct.{$key}.options.{$value_{$key}}}
                                     {else}
-                                        {$value_{$key}}
+                                        {$value_{$key}|idn_to_utf8}
                                     {/if}
                                 {else}
                                     {if $table == 'foo' && $key == 'bar'}
diff -ruN postfixadmin.orig/templates/index.tpl postfixadmin/templates/index.tpl
--- postfixadmin.orig/templates/index.tpl	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/templates/index.tpl	2022-06-07 13:56:11.038735000 +0300
@@ -8,7 +8,7 @@
             {include file='menu.tpl'}
         {/if}
     {/if}
-    <div class="container" style="min-width: 600px; " role="main">
+    <div class="container-fluid" style="margin-top: 60px; min-width: 600px;  " role="main">
         {if $authentication_has_role.user && $CONF.motd_user}
             <div id="motd">{$CONF.motd_user}</div>
         {elseif $authentication_has_role.global_admin && $CONF.motd_superadmin}
diff -ruN postfixadmin.orig/templates/list-virtual.tpl postfixadmin/templates/list-virtual.tpl
--- postfixadmin.orig/templates/list-virtual.tpl	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/templates/list-virtual.tpl	2022-06-07 12:49:43.495753000 +0300
@@ -17,7 +17,7 @@
             {if isset($search._)}
                 <h4>{$PALANG.pSearch_welcome} {$search._}</h4>
             {else}
-                <h4>{$PALANG.pOverview_welcome}{$fDomain} :</h4>
+                <h4>{$PALANG.pOverview_welcome}{$fDomain|idn_to_utf8} :</h4>
                 <ul>
                     <li>{$PALANG.aliases}: {$limit.alias_count} / {$limit.aliases}</li>
                     <li>{$PALANG.mailboxes}: {$limit.mailbox_count} / {$limit.mailboxes}</li>
diff -ruN postfixadmin.orig/templates/list.tpl postfixadmin/templates/list.tpl
--- postfixadmin.orig/templates/list.tpl	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/templates/list.tpl	2022-06-07 12:45:56.293434000 +0300
@@ -64,9 +64,9 @@
 
             {if $field.linkto != '' && ($item.$id_field != '' || $item.$id_field > 0) }
                 {assign "linkto" "{$field.linkto|replace:'%s':{$item.$id_field|escape:url}}"} {* TODO: use label field instead *}
-                {assign "linktext" "<a href='{$linkto}'>{$item.{$key}}</a>"}
+                {assign "linktext" "<a href='{$linkto}'>{$item.$key|idn_to_utf8}</a>"}
             {else}
-                {assign "linktext" $item.$key}
+                {assign "linktext" $item.$key|idn_to_utf8 }
             {/if}
 
             {if $table == 'foo' && $key == 'bar'}
diff -ruN postfixadmin.orig/templates/menu.tpl postfixadmin/templates/menu.tpl
--- postfixadmin.orig/templates/menu.tpl	2021-10-19 00:09:49.000000000 +0300
+++ postfixadmin/templates/menu.tpl	2022-06-07 13:37:48.555039000 +0300
@@ -9,7 +9,7 @@
 
 {strip}
     <nav class="navbar navbar-default navbar-fixed-top">
-        <div class="container">
+        <div class="container-fluid">
             <div class="navbar-header">
                 <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar"
                         aria-expanded="false" aria-controls="navbar">
